<template>
  <div class="w-full content-center">
    <div v-if="!success">
      <h1 class="text-3xl m-10">Inscription</h1>

      <div v-if="error" class="error_alert border-l-4 p-2 m-10" role="alert">
        <p class="font-bold">Une erreur est survenue ...</p>
        <br />
        <p>{{ error }}</p>
      </div>

      <form ref="form" :model="form" class="w-full self-center p-5">
        <div class="flex flex-wrap md:items-center mb-6">
          <div class="md:w-1/4">
            <label
              class="block text-white-700 text-sm font-bold mb-2"
              for="first_name"
              style="float: right;"
            >
              Prénom
            </label>
          </div>
          <div class="md:w-3/4">
            <input
              class="input_text max-w-sm shadow appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
              prop="first_name"
              id="first_name"
              v-model="form.first_name"
              type="text"
              placeholder="Prénom"
            />
            <p
              v-if="form_error.first_name"
              class="text-red-500 text-sm font-bold m-1"
            >
              Le prénom est obligatoire
            </p>
          </div>
        </div>
        <div class="flex flex-wrap md:items-center mb-6">
          <div class="md:w-1/4">
            <label
              class="block text-white-700 text-sm font-bold mb-2"
              for="last_name"
              style="float: right;"
            >
              Nom
            </label>
          </div>
          <div class="md:w-3/4">
            <input
              class="input_text max-w-sm shadow appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
              prop="last_name"
              id="last_name"
              v-model="form.last_name"
              type="text"
              placeholder="Nom"
            />
            <p
              v-if="form_error.last_name"
              class="text-red-500 text-sm font-bold m-1"
            >
              Le nom est obligatoire
            </p>
          </div>
        </div>
        <div class="flex flex-wrap md:items-center mb-6">
          <div class="md:w-1/4">
            <label
              class="block text-white-700 text-sm font-bold mb-2"
              for="email"
              style="float: right;"
            >
              Email
            </label>
          </div>
          <div class="md:w-3/4">
            <input
              class="input_text max-w-sm shadow appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
              prop="email"
              id="email"
              v-model="form.email"
              type="email"
              placeholder="mail@mail.com"
            />
            <p
              v-if="form_error.email"
              class="text-red-500 text-sm font-bold m-1"
            >
              Merci de saisir une adresse Email
            </p>
          </div>
        </div>
        <div class="flex flex-wrap md:items-center mb-10">
          <div class="md:w-1/4">
            <label
              class="block text-white-700 text-sm font-bold mb-2"
              for="password"
              style="float: right;"
            >
              Mot de passe
            </label>
          </div>
          <div class="md:w-3/4">
            <input
              class="input_text max-w-sm shadow appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
              prop="password"
              id="password"
              v-model="form.password"
              type="password"
              placeholder="****************"
            />
            <p
              v-if="form_error.password"
              class="text-red-500 text-sm font-bold m-1"
            >
              Merci de saisir un mot de passe d'au moins 6 caractères
            </p>
          </div>
        </div>
        <div class="flex flex-wrap md:items-center mb-10">
          <div class="md:w-1/4">
            <label
              class="block text-white-700 text-sm font-bold mb-2"
              for="confirm_password"
              style="float: right;"
            >
              Confirmation du mot de passe
            </label>
          </div>
          <div class="md:w-3/4">
            <input
              class="input_text max-w-sm shadow appearance-none border rounded w-full py-2 px-3 text-black-700 leading-tight focus:outline-none focus:shadow-outline"
              prop="confirm_password"
              id="confirm_password"
              v-model="form.confirm_password"
              type="password"
              placeholder="****************"
            />
            <p
              v-if="form_error.confirm_password"
              class="text-red-500 text-sm font-bold m-1"
            >
              Merci de confirmer la saisie du mot de passe
            </p>
          </div>
        </div>
        <div class="flex flex-wrap md:items-center mb-10">
          <br /><br />
          <div class="md:w-1/4"></div>
          <div class="md:w-3/4">
            <button
              class="shadow btn_submit focus:shadow-outline focus:outline-none text-white font-bold py-2 px-4 rounded"
              type="button"
              @click="submit()"
            >
              Inscription
            </button>

            <button
              class="shadow btn_submit focus:shadow-outline focus:outline-none text-white font-bold py-2 px-4 rounded"
              type="button"
              @click="autofill()"
            >
              Autofill
            </button>
          </div>
        </div>
      </form>
    </div>
    <div v-else class="container mx-auto">
      <h1 class="text-3xl m-10">Merci pour votre inscription !</h1>
      <img
        class="image_confirm"
        src="http://localhost:8888/photos_api/photo/56/0/0/1"
        alt="Protest"
      />
      <h4>
        Vous pouvez désormais vous connecter en cliquant sur le lien ci-dessous
        : <br /><br />
        <router-link
          :to="{ name: 'login' }"
          class="navbar_link"
          style="padding: "
        >
          Se connecter
        </router-link>
      </h4>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      form: {
        first_name: "",
        last_name: "",
        email: "",
        phone_number: "",
        password: "",
        confirm_password: "",
      },
      form_error: {
        first_name: false,
        last_name: false,
        email: false,
        phone_number: false,
        password: false,
        confirm_password: false,
      },
      error: null,
      success: false,
    };
  },
  methods: {
    submit() {
      const data = this.form;
      this.error = null;
      this.success = false;

      if (!this.validate(data)) {
        return;
      }

      if (data.password != data.confirm_password) {
        this.error = "Les mots de passe ne correspondent pas";
        return false;
      }

      axios
        .post("http://localhost:8888/photos_api/api/register", data)
        .then((res) => {
          if (res.data.result) {
            this.success = true;
          } else {
            this.error = res.data.error;
          }
        })
        .catch(() => {
          this.error = "Une erreur est survenue";
        });
    },
    validate(data) {
      this.form_error.first_name = false;
      this.form_error.last_name = false;
      this.form_error.email = false;
      this.form_error.phone_number = false;
      this.form_error.password = false;
      this.form_error.confirm_password = false;

      if (data.first_name == "") {
        this.form_error.first_name = true;
        return false;
      } else if (data.last_name == "") {
        this.form_error.last_name = true;
        return false;
      } else if (data.email == "") {
        this.form_error.email = true;
        return false;
      } else if (data.phone_number == "" || data.phone_number.length != 10) {
        this.form_error.phone_number = true;
        return false;
      } else if (data.password == "" || data.password.length < 6) {
        this.form_error.password = true;
        return false;
      } else if (
        data.confirm_password == "" ||
        data.confirm_password.length < 6
      ) {
        this.form_error.confirm_password = true;
        return false;
      }
      return true;
    },
    autofill() {
      this.form.first_name = "test";
      this.form.last_name = "test";
      this.form.email = "max.belbeoch5@gmail.com";
      this.form.phone_number = "1234567890";
      this.form.password = "aaaaaa";
      this.form.confirm_password = "aaaaaa";
    },
  },
};
</script>
